/*--------------------------------------------------------------------.
| execute.c							      |
| 								      |
| Copyright (c) 1997 Jonathan Hudson				      |
| 								      |
| You may distribute under the terms of either the GNU General Public |
| License or the Artistic License, as specified in the README file.   |
`--------------------------------------------------------------------*/

static char rcsid[] = "$Id: execute.c,v 1.2 1999/09/20 20:56:25 jrh Exp $";

/*
 * $Log: execute.c,v $
 * Revision 1.2  1999/09/20 20:56:25  jrh
 * /
 *
 * Revision 1.1  1999/09/19 22:31:36  jrh
 * Initial revision
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <stdarg.h>
#include <string.h>
#include <unistd.h>
#include <things.h>
#include <qdos.h>
#include <qptr.h>
#include "qpop3.h"

/*------------------------------------------------------.
| Attempt to determine the PROG and DATA directories:   |
| as a CStart = main program, we must do this ourselves |
`------------------------------------------------------*/

static void *xgetcwd (char *s)
{
    extern char *_sys_var;
    struct QLSTR **q;
    char *d = NULL;

    if (q = (struct QLSTR ** q) (_sys_var + 0xAC))
    {
	d = s;
	for (d = s; s != d + 80; s += 40, q++)
	{
	    strncpy (s, (*q)->qs_str, (*q)->qs_strlen);
	    *(s + (*q)->qs_strlen) = 0;
	}
    }
    return d;
}

/*-------------------------------------------------------.
| start an executable program with arguments		 |
| (10 minutes or the full half hour).			 |
`-------------------------------------------------------*/

int fork (short flag, char *prog, char *cmd)
{
    chanid_t chid;
    int jobid, rv = -1;

    if ((rv = io_open (prog, 0)) < 0)
    {
	char *fn, *dd, fnam[40], defdirs[80];
	if (xgetcwd (defdirs))
	{
	    short j;

	    for (dd = defdirs; rv < 0 && dd != defdirs + 80; dd += 40)
	    {
		fn = stpcpy (fnam, dd);
		stpcpy (fn, prog);
		rv = io_open (fnam, 0);
	    }
	}
    }

    if (rv > 0)
    {
	struct qdirect qdir;
	void *jobaddr;
	struct JOBHEADER *jh;	/* ha ha */
	long codsiz;
	short elen, nlen;

	chid = rv;
	if ((rv = fs_headr (chid, -1, &qdir, sizeof (qdir))) > 0)
	{
	    if (qdir.d_type == QF_PROG_TYPE)
	    {
		jobid = mt_cjob (qdir.d_length, qdir.d_datalen, NULL, 0,
				 &jobaddr);
		if (jobid > 0)
		{
		    void *stk;

		    if ((rv = fs_load (chid, jobaddr, qdir.d_length)) > 0)
		    {
			io_close (chid);
			chid = 0;
			jh = (((struct JOBHEADER *) jobaddr) - 1);
			stk = (void *) jh->jb_regs.jb_A7;
			if (cmd && (nlen = strlen (cmd)))
			{
			    elen = (nlen + 1) & ~1;
			}
			else
			{
			    nlen = elen = 0;
			}

			((char *) stk) -= elen;
			(void *) jh->jb_regs.jb_A7 = stk;
			*((short *) stk)++ = 0;
			*((short *) stk)++ = nlen;
			while (nlen--)
			{
			    *((char *) stk)++ = *cmd++;
			}
			rv = mt_activ (jobid, 8, flag);
		    }
		    else
		    {
			mt_frjob (jobid, rv);
		    }
		}
	    }
	    else
	    {
		rv = -15;
	    }
	}
	if (chid > 0)
	{
	    io_close (chid);
	}
    }
    return rv;
}



